<?php
session_start();
// Set up
$version="1.1";
//session_register("dimx","dimy","nummines","board","numflags","cleared");
$newgame = 'no';
srand(time());
$dead=0;

if((isset($_POST['newgame']) AND $_POST['newgame'] == 'yes') OR (isset($_GET['newgame']) AND $_GET['newgame'] == 'yes'))
{
	
	$width = $_POST['width'] ? $_POST['width'] : ($_SESSION['dimx'] ? $_SESSION['dimx'] : 0);
	$height = $_POST['height'] ? $_POST['height'] : ($_SESSION['dimy'] ? $_SESSION['dimy'] : 0);
	$mines = $_POST['mines'] ? $_POST['mines'] : ($_SESSION['nummines'] ? $_SESSION['nummines'] : 0);
	$newgame = 'yes';
	session_destroy();
	$_SESSION = array();
	session_start();
}
if(isset($_GET['action']) AND isset($_GET['mx']) AND isset($_GET['my']))
{
	$action = $_GET['action'];
	$mx = $_GET['mx'];
	$my = $_GET['my'];
}
if(isset($_SESSION['board']))
{
	$board = $_SESSION['board'];
	$dimx = $_SESSION['dimx'];
	$dimy = $_SESSION['dimy'];
	$nummines = $_SESSION['nummines'];
	$numflags = $_SESSION['numflags'];
	$cleared = $_SESSION['cleared'];
}

// Functions

function cleararound($x,$y)
{
  global $board;
  global $dimx;
  global $dimy;
  if(($board[$x][$y]["mcount"] == $board[$x][$y]["flagcount"]) && ($x>0) && ($x<=($dimx)) && ($y>0) && ($y<=($dimy)))
  {
    if($board[$x-1][$y-1]["flagged"]+$board[$x-1][$y-1]["clicked"]==0)
    {
      clearcell($x-1,$y-1);
    }
    if($board[$x][$y-1]["flagged"]+$board[$x][$y-1]["clicked"]==0)
    {
      clearcell($x,$y-1);
    }
    if($board[$x+1][$y-1]["flagged"]+$board[$x+1][$y-1]["clicked"]==0)
    {
      clearcell($x+1,$y-1);
    }
    if($board[$x-1][$y]["flagged"]+$board[$x-1][$y]["clicked"]==0)
    {
      clearcell($x-1,$y);
    }
    if($board[$x+1][$y]["flagged"]+$board[$x+1][$y]["clicked"]==0)
    {
      clearcell($x+1,$y);
    }
    if($board[$x-1][$y+1]["flagged"]+$board[$x-1][$y+1]["clicked"]==0)
    {
      clearcell($x-1,$y+1);
    }
    if($board[$x][$y+1]["flagged"]+$board[$x][$y+1]["clicked"]==0)
    {
      clearcell($x,$y+1);
    }
    if($board[$x+1][$y+1]["flagged"]+$board[$x+1][$y+1]["clicked"]==0)
    {
      clearcell($x+1,$y+1);
    }
  }
}

function clearcell($x,$y)
{
  global $dead;
  global $board;
  global $cleared;
  global $dimx;
  global $dimy;
  if($board[$x][$y]["mine"]==1)
  {
    $board[$x][$y]["clicked"]=1;
    $dead=1;
    return;
  }
  elseif($board[$x][$y]["clicked"]==0)
  {
    $board[$x][$y]["clicked"]=1;
    $cleared++;
    if($x==0){$cleared--;return;}
    if($y==0){$cleared--;return;}
    if($x==$dimx+1){$cleared--;return;}
    if($y==$dimy+1){$cleared--;return;}
  }
  if($board[$x][$y]["mcount"]==0)
  {
    cleararound($x,$y);
  }
}

function flag($x,$y)
{
  global $board;
  global $numflags;
  if($board[$x][$y]["flagged"]==0)
  {
    $board[$x][$y]["flagged"]=1;
    $numflags++;
  }
}

function unflag($x,$y)
{
  global $board;
  global $numflags;
  if($board[$x][$y]["flagged"]==1)
  {
    $board[$x][$y]["flagged"]=0;
    $numflags--;
  }
}


if(($newgame=="yes") || (!isset($board)))
{
	if(isset($width))
	{
	  $dimy = $width;
	}

	if(isset($height))
	{
	  $dimx = $height;
	}

	if(isset($mines))
	{
	  $nummines = $mines;
	}

	if($dimx<=0)
	{
	  $dimx=10;
	}

	if($dimy<=0)
	{
	  $dimy=10;
	}

	if($nummines<=0)
	{
	  $nummines=20;
	}

	if(($dimx*$dimy)>=1000)
	{
	  $dimx=10;
	  $dimy=10;
	}

	if($nummines>($dimx*$dimy))
	{
	  $nummines=$dimx*$dimy;
	}
  $newgame="no";
  $numflags=0;
  $cleared=0;
  $board = array();
  for($i=0;$i<=($dimx+1);$i++)
  {
    for($j=0;$j<=($dimy+1);$j++)
    {
      $board[$i][$j]["mine"]=0;
      $board[$i][$j]["clicked"]=0;
      $board[$i][$j]["flagged"]=0;
      $board[$i][$j]["flagcount"]=0;
	  $board[$i][$j]["mcount"]=0;
    }
  }

  for($m=0;$m<$nummines;$m++)
  {
    $tx=rand(1,$dimx);
    $ty=rand(1,$dimy);
    if(($board[$tx][$ty]["mine"]==1))
    {
      $m--;
    }
    else
    {
      $board[$tx][$ty]["mine"]=1;
    }
  }

  for($i=1;$i<=($dimx);$i++)
  {
    for($j=1;$j<=($dimy);$j++)
    {
      $board[$i][$j]["mcount"]=
        $board[$i-1][$j-1]["mine"] +
        $board[$i][$j-1]["mine"] +
        $board[$i+1][$j-1]["mine"] +
        $board[$i-1][$j]["mine"] +
        $board[$i+1][$j]["mine"] +
        $board[$i-1][$j+1]["mine"] +
        $board[$i][$j+1]["mine"] +
        $board[$i+1][$j+1]["mine"];
    }
  }
}

for($i=1;$i<=$dimx;$i++)
{
  for($j=1;$j<=$dimy;$j++)
  {
    $board[$i][$j]["flagcount"]=
      $board[$i-1][$j-1]["flagged"] +
      $board[$i][$j-1]["flagged"] +
      $board[$i+1][$j-1]["flagged"] +
      $board[$i-1][$j]["flagged"] +
      $board[$i+1][$j]["flagged"] +
      $board[$i-1][$j+1]["flagged"] +
      $board[$i][$j+1]["flagged"] +
      $board[$i+1][$j+1]["flagged"];
  }
}

if(isset($action))
{
  switch($action)
  {
    case "clear":
      clearcell($mx,$my);
      break;
    case "cleararound":
      cleararound($mx,$my);
      break;
    case "flag":
      flag($mx,$my);
      break;
    case "unflag":
      unflag($mx,$my);
      break;
  }
}
$minesleft = $nummines - $numflags;

$_SESSION['board'] = $board;
$_SESSION['dimx'] = $dimx;
$_SESSION['dimy'] = $dimy;
$_SESSION['nummines'] = $nummines;
$_SESSION['numflags'] = $numflags;
$_SESSION['cleared'] = $cleared;

?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="de" lang="de">
<head>
<title>Minesweeper</title>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8"/>
<style type="text/css">
body { color:#DDD; background-color:#077; font:12px/14px Arial, Verdana, sans-serif; }
a:link { color:#00D; }
a:hover { color:#CCC; }
a:visited { color:#00D; }
img { display:inline; border:0; }
table { border-collapse:collapse; border-spacing:0; line-height:14px; }
table#game { line-height:0; }
table#game td { height:14px; width:14px; background-color:#DDD; padding:0px; }
strong { color:#C30; }
</style>
</head>
<body>
<div style="width:500px; margin:auto;">
<table style="width:<?php print (16*$dimx)+2; ?>px; margin:auto;" border="0" cellpadding="0" cellspacing="0">
	<tr>
		<td style="width:14px; background-color:#22B;" align="center"> <img alt="" width="14" height="14" src="mpics/mine.png" /></td>
		<td style="height:14px; background-color:#22B; line-height:14px; text-align:center;"><tt>Minesweeper</tt></td>
		<td style="width:14px; background-color:#22B;" align="center"><img alt="" width="14" height="14" src="mpics/close.png" /></td>
	</tr>
	<tr>
		<td colspan="3"><table style="width:100%"><tr>
		<td style="width:25%; background-color:#AAA; text-align:center;"><strong style="color:#DDD;"><?php print $minesleft; ?></strong></td>
		<td style="width:50%; background-color:#AAA; height:26px;" align="center"><a href="<?php print $_SERVER['SCRIPT_NAME']."?newgame=yes"; ?>"><img alt="Smiley" src="mpics/button<?php
if (($dimx * $dimy) - ($nummines + $cleared) == 0)
{
  print "shades";
}
elseif ($dead==1)
{
  print "dead";
}
else
{
  print "smile";
}

?>.png" width="27" height="26" /></a></td>
		<td style="width:25%; background-color:#AAA;">&nbsp;</td></tr></table></td>
	</tr>
	<tr>
		<td style="background-color:#000;" colspan="3">
			<table id="game" border="0" cellpadding="0" cellspacing="1" style="width:100%; height:<?php print (16*$dimx); ?>px;">
<?php

for($i=1;$i<=($dimx);$i++)
{
  print "<tr>\n";
  for($j=1;$j<=$dimy;$j++)
  {
    print "  <td align=\"center\">";
    {
      if($board[$i][$j]["flagged"]==1)
      {
        if($dead==1)
        {
          if($board[$i][$j]["mine"]==1)
          {
            print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/flag.png\" />";
          }
          else
          {
            print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/wrong.png\" />";
          }
        }
        else
        {
          print "<a href=\"".$_SERVER['SCRIPT_NAME']."?".SID."&amp;action=unflag&amp;mx=".$i."&amp;my=".$j."\"><img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/flag.png\" /></a>";
        }
      }
      elseif($board[$i][$j]["clicked"]==0)
      {
        if($dead==1)
        {
          if($board[$i][$j]["mine"]==1)
          {
            print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/mine.png\" />";
          }
          else
          {
            print "<img alt=\"\" width=\"7\" height=\"14\" src=\"mpics/clear0.png\" />";
            print "<img alt=\"\" width=\"7\" height=\"14\" src=\"mpics/clear1.png\" />";
          }
        }
        else
        {
          print "<a title=\"clear\" href=\"".$_SERVER['SCRIPT_NAME']."?".SID."&amp;action=clear&amp;mx=".$i."&amp;my=".$j."\"><img alt=\"clear\" width=\"7\" height=\"14\" src=\"mpics/clear0.png\" /></a>";
          print "<a title=\"flag\" href=\"".$_SERVER['SCRIPT_NAME']."?".SID."&amp;action=flag&amp;mx=".$i."&amp;my=".$j."\"><img alt=\"flag\" width=\"7\" height=\"14\" src=\"mpics/clear1.png\" /></a>";
        }
      }
      elseif($board[$i][$j]["mine"]==1)
      {
        print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/redmine.png\" />";
      }
      elseif($board[$i][$j]["mcount"]==0)
      {
        print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/clear.png\" />";
      }
      else
      {
        if($dead==1)
        {
          print "<img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/num{$board[$i][$j]["mcount"]}.png\" />";
        }
        else
        {
          print "<a href=\"".$_SERVER['SCRIPT_NAME']."?".SID."&amp;action=cleararound&amp;mx=".$i."&amp;my=".$j."\"><img alt=\"\" width=\"14\" height=\"14\" src=\"mpics/num{$board[$i][$j]["mcount"]}.png\" /></a>";
        }
      }
    }
    print "</td>\n";
  }
  print "</tr>\n";
}

?>
			</table>
		</td>
	</tr>
</table>
<p>To uncover a cell, click into the <strong>left</strong> half of it, to set a flag, click into the <strong>right</strong> half of a cell</p>
<hr />
<h2>Configure</h2>
<form method="post" action="<?php print $_SERVER['SCRIPT_NAME']; ?>">
<table border="3">
<tr><td>Width of minefield:</td><td><input type="text" name="width" value="<?php print $dimy; ?>" /></td></tr>
<tr><td>Height of minefield:</td><td><input type="text" name="height" value="<?php print $dimx; ?>" /></td></tr>
<tr><td>Number of mines:</td><td><input type="text" name="mines" value="<?php print $nummines; ?>" /></td></tr>

<tr><td align="center" colspan="2"><input type="hidden" name="newgame" value="yes" /><input type="submit" name="button" value="Start new game" /></td></tr>
</table>
</form>
<hr />
<p>Version <?php print $version; ?>, Copyright &copy; <a href="mailto:Brian.Ronald@unforgettable.com">Brian Ronald</a>, 2001<br />
Released under the <a href="http://www.gnu.org/copyleft/lesser.html">GNU Lesser General Public License</a><br />
Version 1.0 is <a href="http://minesweeper-php.sourceforge.net/">here</a><br />
More information at <a href="http://sourceforge.net/projects/minesweeper-php/">http://sourceforge.net/projects/minesweeper-php/</a><br />
Edited by <a href="http://www.p-six.de/sign">Jürgen Müller-Lütken,</a> 09/2012<br />
<a href="PHP-Minesweeper.zip">Download this version</a></p>
</div>
</body>
</html>
